Skip to main content

List devices

Request

Retrieve a list of devices.

Filtering by custom properties

Use the query parameter to filter devices on custom properties. Syntax:

  • properties.key:value: matches devices with a property that contains a key named key with a value of value; use double quotes if the value contains spaces or special characters
  • properties.key:value1,value2: matches devices with a property that contains a key named key and its value is either value1 or value2
  • properties.key:*: matches devices with a property that contains a key named key and any value
  • *:value: matches devices with a property that contains a key with any name and a value of value
  • foo: matches devices with properties where any key or stringified value contains foo Multiple qualifiers can be used in the same query string; this will filter devices matching the intersection of the qualifiers (AND).
Security
ApiKey(Required scopes: devices.list)
Query
projectIdstring

Filter devices by project

sortBystring

Field to sort items by ("id", "name", or a custom property key prefixed with properties.)

querystring

Space-separated query string for device custom properties. Each custom property key must be valid and prefixed with "properties.". See above for syntax and examples.

sortOrderstring

Sort order for the sortBy field

Enum:"asc""desc"
limitnumber, [ 0 .. 2000 ]

Maximum number of items to return

Default:2000
offsetinteger, >= 0

Number of items to skip before returning the results

Default:0
Python
from foxglove.client import Client

token = "<YOUR API TOKEN HERE>"
client = Client(token=token)

client.get_devices()

Responses

List of devices

Bodyapplication/json
Array [
idstringrequired

Opaque identifier

namestringrequired

Organization-chosen device name

projectIdstringrequired

The project ID that the device belongs to

retainRecordingsSecondsnumber

Retention period for recordings on a device running Foxlet, in seconds. Set to 0 to retain recordings indefinitely.

propertiesobject(CustomPropertyValues)

A key-value map of the custom properties associated with this device.

enabledbooleanrequired

Whether this device is enabled. Devices are enabled by default, unless they are created with a device token with preapproved set to false. Disabled devices show up in the device list, but you can't upload recordings for them. A device token linked to a disabled device does not grant access to the API.

remoteAccessEnabledbooleanrequired

Whether remote access is enabled for this device. When disabled, the device cannot establish new remote access sessions.

autoDeleteAfterImportbooleanrequired

Whether recordings on this device are automatically deleted once they have been successfully uploaded and accepted for import. This is only relevant for devices that have Foxlet installed.

orgIdstring
createdAtstring, (date)
updatedAtstring, (date-time)
]
Response
[ { "id": "string", "name": "string", "projectId": "string", "retainRecordingsSeconds": 0, "properties": { … }, "enabled": true, "remoteAccessEnabled": true, "autoDeleteAfterImport": true, "orgId": "string", "createdAt": "2019-08-24", "updatedAt": "2019-08-24T14:15:22Z" } ]